#!/bin/sh

#sudo -u postgres /usr/local/pgsql/bin/postmaster -D /usr/local/pgsql/data > log$
#vncserver
#service mysqld start

#apachectl start

function gather_hosts()
{
	
	#loop into db(s) ip(s)
	i=1
	while [ $i -lt `expr $NUM_DB + 1` ]
	do
		#set hostname
		ssh $1 "/opt/scripts/sethostname.sh rubis_db$i"	
		#add host in the list
		HOSTS_LIST=$HOSTS_LIST' '$1' rubis_db'$i
		#check finger print
		./check_finger_print.sh rubis_db$i
		shift
		let "i=i + 1"
	done 

	#loop into jboss(s) ip(s)
	i=1
	while [ $i -lt `expr $NUM_JBOSS + 1` ]
	do
		ssh $1 "/opt/scripts/sethostname.sh rubis_jboss$i"
		HOSTS_LIST=$HOSTS_LIST' '$1' rubis_jboss'$i
		#check finger print
		./check_finger_print.sh rubis_jboss$i
		shift
		let "i=i + 1"
	done 

	#loop into apache(s) ip(s)
	i=1
	while [ $i -lt `expr $NUM_APACHE + 1` ]
	do
		ssh $1 "/opt/scripts/sethostname.sh rubis_apache$i"
		HOSTS_LIST=$HOSTS_LIST' '$1' rubis_apache'$i
		#check finger print
		./check_finger_print.sh rubis_apache$i
		shift
		let "i=i + 1"
	done 

	#loop into client(s) ip(s)
	i=1
	while [ $i -lt `expr $NUM_CLIENT + 1` ]
	do
		ssh $1 "/opt/scripts/sethostname.sh rubis_client$i"
		HOSTS_LIST=$HOSTS_LIST' '$1' rubis_client'$i
		#check finger print
		./check_finger_print.sh rubis_client$i
		shift
		let "i=i + 1"
	done 
 
	echo $HOSTS_LIST
	

}

function add_hosts_on_my_computer()
{
	while [ $1 ]
	do
		tmp=`cat /etc/hosts | grep -o $1`
	  #if it is empty
	   if [ ! "$tmp" ];then
     	  echo -e $1 '\t\t'$2.epfl.ch'\t'$2 >>/etc/hosts
	  else 
		#delete and replace the line with the new address

		sed -i.old -e /$2/d /etc/hosts
		echo -e $1 '\t\t'$2'\t'$2.epfl.ch >>/etc/hosts
        fi
	 #shift twice
        shift 2
	done

	
}

function set_hosts()
{
	
	#set the host for everybody ( domU )
	i=1
	while [ $i -lt `expr $NUM_DB + $NUM_JBOSS + $NUM_APACHE + $NUM_CLIENT + 1` ]
	do
		ssh $1 "/opt/scripts/sethosts.sh $HOSTS_LIST" #set host list
		ssh $1 "service vncserver restart" #restart vnc
		ssh -x $1 "vncserver -geometry 1280x800 </dev/null >/dev/null 2>&1 & " #start a Xvnc session
				
		shift
		let "i=i + 1"
	done 
	
	add_hosts_on_my_computer $HOSTS_LIST

}

function start_clients()
{
    apache_index=1;
    i=1
    while [ $i -lt `expr $NUM_CLIENT + 1` ]
    do
        #init client
        #set gmetad host
        ssh rubis_client$i "/opt/scripts/setgmetadhosts.sh $HOSTS_LIST"
        #start apache
        ssh rubis_client$i "service httpd restart"
        #start gmetad
        ssh rubis_client$i "/etc/rc.d/init.d/gmetad start  "
       
        #set apache in rubis_properties
        if [ $apache_index -lt `expr $NUM_APACHE + 1` ]; then
            ssh rubis_client$i "/opt/scripts/setapacheclient.sh rubis_apache$apache_index"
        else
            apache_index=0
            ssh rubis_client$i "/opt/scripts/setapacheclient.sh rubis_apache$apache_index"
        fi
       
        #increment
        let "i = i + 1"
        let "apache_index = apache_index + 1"
    done   
}

function start_apaches()
{
	
	i=1
	while [ $i -lt `expr $NUM_APACHE + 1` ] 
	do
		#set workers
		ssh rubis_apache$i "/opt/scripts/setjbossworkernode.sh $JBOSS_LIST" 
		#start apache
		ssh rubis_apache$i "service httpd restart" 

		let "i=i + 1"	
	done	
}

function start_jboss()
{
	
	i=1
	while [ $i -lt `expr $NUM_JBOSS + 1` ] 
	do
		#set node id
		ssh rubis_jboss$i "/opt/scripts/setjbossnodeid.sh node$i"
		#set db ip use one for now
		ssh rubis_jboss$i "/opt/scripts/setdbip.sh rubis_db1"
		#run jboss (to improve the path ain't looking good )
		ssh -x rubis_jboss$i "cd /root/rubis/RUBIS/Servlets_Hibernate; ./jbossrun.sh rubis_jboss$i </dev/null >/dev/null 2>&1 & "
		#JBOSS_LIST=$JBOSS_LIST' node$i rubis_jboss'$i
		JBOSS_LIST=$JBOSS_LIST' node'$i' rubis_jboss'$i
		let "i=i + 1"	
	done	
	echo workers are $JBOSS_LIST
	echo jboss is starting...
	sleep 30
}

function start_dbs()
{
	
	i=1
	while [ $i -lt `expr $NUM_DB + 1` ] 
	do
		#start mysql
		ssh rubis_db$i "service mysqld restart"
		
		let "i=i + 1"	
	done	
	
}

function start_diskmetrics()
{
	
	i=1
	while [ $i -lt `expr $NUM_DB + $NUM_JBOSS + $NUM_APACHE + $NUM_CLIENT + 1` ]
	do
		#start ganglia gmond for udp sending and receiving
		ssh $1 "/etc/rc.d/init.d/gmond start" #start ganglia gmond for udp sending and receiving
		#ssh -x $1 "/opt/scripts/ganglia-metric/disk_metric_daemon.sh start </dev/null >/dev/null 2>&1 & "
		
		shift
		let "i=i + 1"
	done 
}

NUM_CLIENT=$4
NUM_APACHE=$3
NUM_JBOSS=$2
NUM_DB=$1

JBOSS_LIST=''
shift 4

gather_hosts $*
set_hosts $*



start_dbs
start_jboss
start_apaches
start_clients
#all manual metric published before gmetad start make the latter behave weirdly. thus we have to launch diskmetric script once everything is deploy.
start_diskmetrics $*

