#!/bin/sh
#setup the bridge for dhcp

if [ "$#" != 1 ] ; then
	echo " Usage : $0 {start|stop} "
	exit 127
fi

case $1 in 
"start")
	MYBRUSED=`brctl show|grep rubisbr0`
 
	if [ "$MYBRUSED" != "" ]; then
		echo ">> found bridge  rubisbr0 and reseted it"
		ip link set  rubisbr0 down
		brctl delbr  rubisbr0
	fi

	brctl addbr rubisbr0
	ip addr add 192.168.1.1/24 dev rubisbr0
	ip link set rubisbr0 up
	iptables -t filter -F
  	iptables -t mangle -F
  	iptables -t nat    -F
  	iptables -t filter -P FORWARD DROP
  	iptables -t mangle -A FORWARD -i rubisbr0  -o eth0 -j MARK --set-mark 1
	iptables -t filter -A FORWARD -m state --state ESTABLISHED,RELATED -j ACCEPT
	iptables -t filter -A FORWARD -m mark --mark 1 -j ACCEPT
  	iptables -t nat -A POSTROUTING -m mark --mark 1 -j MASQUERADE
	service dhcpd restart
	xend stop
	xend start
	;;
"stop")
	 MYBRUSED=`brctl show|grep rubisbr0`

        if [ "$MYBRUSED" != "" ]; then
                echo ">> found bridge  rubisbr0 and switched it down"
                ip link set  rubisbr0 down
                brctl delbr  rubisbr0
        fi

	;;
esac

