#!/bin/bash


function get_val_from_position
{
	pos=$1; 
	shift $pos
	VAL=$1
} 

function grab_and_publish_metric_at_index_for_device
{
 #$1 is the device
 # the rest are metric indexes
 mydevice=$1; shift
i=0
 while [ $1 ]
 do
	#grabing the right column for the metric 
	VAL=''
	get_val_from_position $1 `cat disk_stat | grep $mydevice `
	
	let "i=i+1"
	metric=`echo $METRICLIST | cut -d' ' -f $i`
	
	#echo 'gmetric -t float  -n '$metric'_'$mydevice' -v '$VAL
	gmetric -t float -n $metric'_'$mydevice -v $VAL
	
	shift
 done	
}

#$1 is the devices to publish if nothing gmond will publish all devices
# Work out what multicast channel we are on (rather assumes there is only one space).
MCAST=`grep '^mcast_channel' /etc/gmond.conf | cut -d' ' -f 2`
PORT=`grep '^mcast_port' /etc/gmond.conf | cut -d' ' -f 2`
TTL=`grep '^mcast_ttl' /etc/gmond.conf | cut -d' ' -f 2`
 
[ -z "$MCAST" ] && MCAST="239.2.11.70"
[ -z "$PORT" ]  && PORT=8649
[ -z "$TTL" ] && TTL=1

# start gathering headers 
`iostat -d -k > disk_stat`
HEADERS=` grep -i device disk_stat`
METRICLIST='tps kB_read/s kB_wrtn/s'
METRICINDEX=''
DEVICES=''

#fill the device list
if [ $# -gt 0 ]; then
	DEVICES=$@
else
#if No argument, we will grab data from the iostat output
	FIRSTCOLUMN=`gawk '{ print $1 }' disk_stat`
	start_device_pick=0
	for dev in ${FIRSTCOLUMN[@]}
	do 
		if [ $start_device_pick = 1 ]; then
			DEVICES=$DEVICES' '$dev
		fi
		if [ $dev == "Device:" ]; then
			start_device_pick=1
		fi  
	done

fi

#using the header to get the metric index

for m in ${METRICLIST[@]}
do 
	i=0
	for metric in ${HEADERS[@]}
	do 
		let "i=i+1"
		if [ $m = $metric ]; then
			METRICINDEX=$METRICINDEX''$i' '
		fi	
		
	done
done

#start publishing for each devices info

while [ 1 ] ; do
for dev in ${DEVICES[@]}
do 
	grab_and_publish_metric_at_index_for_device $dev $METRICINDEX
done
sleep 5
done
	


 
 

 
