#!/bin/sh

mydomain='epfl.ch'
numberofhosts=`expr $# / 2`


if [ $numberofhosts == 0 ]; then
	
	echo 'USAGE: ' $0 'nodeid2 host1 nodeid2 host2 ...' 
	exit 1
fi

filetomodify='/etc/httpd/conf/workers.properties'
allnodes=''
count=0

echo -e '#' Define list of workers that will be used \
'\n#' for mapping requests \
'\n#' The configuration directives are valid  \
'\n#' for the mod_jk version 1.2.18 and later \
'\n#' \
'\n'worker.list=loadbalancer,status >$filetomodify

while [ $1 ]
do 
	echo -e '\n#' Define $1 \
	'\n#' modify the host as your host IP or DNS name \
	'\n'worker.$1.port = 8009 \
	'\n' worker.$1.host = $2 \
	'\n' worker.$1.type = ajp13 \
	'\n' worker.$1.lbfactor = 1 \
	'\n#' worker.$1.connection_pool_size = 10  \
	'\n' >>$filetomodify
	if [ $count = 0 ];then
		allnodes="$allnodes$1"
		let "count=count + 1"
	else
		
		allnodes="$allnodes,$1"
	fi
	#shift twice
	shift 2
done	


echo -e '\n\n#' Load-balancing behaviour \
	'\n'worker.loadbalancer.type'='lb \
	'\n'worker.loadbalancer.balance_workers'='$allnodes \
	>>$filetomodify

echo -e '\n\n#' Status worker for managing load balancer \
	'\n'worker.status.type'='status >>$filetomodify

